//+------------------------------------------------------------------+
//|                                   Double Correlation Trading.mq4 |
//|                                                          Novikov |
//|                                               info@novikov.dp.ua |
//+------------------------------------------------------------------+
#property copyright "info@novikov.dp.ua"
#property link      "www.novikov.dp.ua"

extern string  menucomment01  = "  ------------------------------------------------------------";
extern string  comment        = "DCT-";   //    
extern int     magic          = 9238;     // 
extern double  First_pair_lot = 0.1;      //     .  Refinans - True,  LotSize   10000 
extern bool    start_work     = true;     // /   

extern string  menucomment02  = "  ------------------------------------------------------------";
extern string  TradingPairs   = "EURUSD;USDCHF;GBPUSD;AUDCAD"; //     
extern string  BanOnPair      = "EURUSD-GBPUSD";               //    
extern string  DopSymbol      = "";    //     
extern bool    Refinans       = false; // True -    First pair lot   10000 , False -      First pair lot             
extern double  TakeProfit     = 1;     //        ADR  ,  0 - .
extern double  MinimumADR     = 50;    //  ADR   ,        
extern int     MartinType     = 1;     // 0  1  2  3  4.  1  2,      ,       StepMartin, 
                                       //      TakeProfit.  3  4,     ,     
                                       //  LotExponent             SeriesMartin     .
extern double  LotExponent    = 2;     //     MartinType - 1  3
extern double  StepMartin     = 0.5;   //      ADR  .
extern int     SeriesMartin   = 5;     //   
extern double  TrailingStop   = 0;     //      ADR  .

extern string  menucomment03  = "  ------------------------------------------------------------";
extern bool    OPCorrelations = true;  // true -     (Period Correlation  DC LevelMinus  -100)
extern bool    PPCorrelations = true;  // true -     (Period Correlation  DC LevelPlus  100).
extern int     time_frame     = 0;     // 
extern int     DC_period      = 120;   //     
       int     DC_smoothing   = 2;
       int     DC_MA_period   = 24;
       int     DC_MA_mode     = 2;
extern double  DC_LevelMinus  = -80;   //       (Period Correlation  -80  -100)
extern double  DC_LevelPlus   = 80;    //       (Period Correlation  80  100)
extern int     Rperiod        = 50;    //   Triggerlines
extern int     LSMA_Period    = 50;    //   Triggerlines

extern string  menucomment04  = "  ------------------------------------------------------------";
extern bool    HalfFilter          = true;   // false -    , true -   
extern int     half_time_frame     = 240;    // 
extern int     half_DC_period      = 120;    //     
       int     half_DC_smoothing   = 2;
       int     half_DC_MA_period   = 24;
       int     half_DC_MA_mode     = 2;
extern double  half_DC_LevelMinus  = -80;    //       (Period Correlation  -80  -100)
extern double  half_DC_LevelPlus   = 80;     //       (Period Correlation  80  100)
extern int     half_Rperiod        = 50;     //   Triggerlines
extern int     half_LSMA_Period    = 50;     //   Triggerlines

extern string  menucomment05  = "  ------------------------------------------------------------";
extern int     CommetSize     = 7;
       int     TryToTrade     = 20;
       int     WaitTime       = 1500;

int i, t, c, dg, dig, last_ticket, time_bar[];
bool Work=true, Test=false, long_allowed=true, short_allowed=true;
double Pp, Pp2, Mnoj, Mnoj2;
string Symb,CommentBox[],cm2;
int pairs;
string Symb1[],Symb2[];
double ADR1[],ADR2[],PC[];
double fibo[];
string cor[2]= { "-OP", "-PP" };
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void start() {
   if (!Work) return;
   string info_signal;
   for(t=0;t<pairs;t++) {
      double ask1=MarketInfo(Symb1[t],MODE_ASK),
             ask2=MarketInfo(Symb2[t],MODE_ASK),
             bid1=MarketInfo(Symb1[t],MODE_BID),
             bid2=MarketInfo(Symb2[t],MODE_BID),
             Pp1 =MarketInfo(Symb1[t],MODE_POINT),
             Pp2 =MarketInfo(Symb2[t],MODE_POINT);
      if(Pp1==0.001 || Pp1==0.00001) Pp1*=10;
      if(Pp2==0.001 || Pp2==0.00001) Pp2*=10;
      string pair_name=StringConcatenate(comment,Symb1[t],"-",Symb2[t]);
      //   ================================================
      int close[2]= { -1,-1 };
      int signal[2]= { -1,-1 };
      if (time_bar[t]!=iTime(Symb,time_frame,0)) {
         time_bar[t]=iTime(Symb,time_frame,0);
         iCustom(NULL,time_frame,"Double Correlation",DC_period,Symb1[t],Symb2[t],DC_smoothing,1.0,1,1,DC_MA_period,DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",0,1);
         PC[t]=StrToDouble(ObjectDescription("PC1"));
         ADR1[t]=MathAbs(StrToDouble(ObjectDescription("ADR1")));
         ADR2[t]=MathAbs(StrToDouble(ObjectDescription("ADR2")));
         if(PC[t]==0 || ADR1[t]==0 || ADR2[t]==0) {
            time_bar[t]=0; 
            continue;
            }
         double PC_half;
         int half_trig1=-1,half_trig2=-1;
         if(HalfFilter) {
            iCustom(NULL,half_time_frame,"Double Correlation",half_DC_period,Symb1[t],Symb2[t],half_DC_smoothing,1.0,1,1,half_DC_MA_period,half_DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",0,1);
            iCustom(NULL,half_time_frame,"Double Correlation",half_DC_period,Symb1[t],Symb2[t],half_DC_smoothing,1.0,1,1,half_DC_MA_period,half_DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",0,1);
            PC_half=StrToDouble(ObjectDescription("PC1"));
            if(iCustom(Symb1[t],half_time_frame,"Triggerlines",half_Rperiod,half_LSMA_Period,2,1)<ask1*2) half_trig1=0; else half_trig1=1;
            if(iCustom(Symb2[t],half_time_frame,"Triggerlines",half_Rperiod,half_LSMA_Period,2,1)<ask2*2) half_trig2=0; else half_trig2=1;
            }
         double _4=iCustom(NULL,time_frame,"Double Correlation",DC_period,Symb1[t],Symb2[t],DC_smoothing,1.0,1,1,DC_MA_period,DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",4,1);
         double _5=iCustom(NULL,time_frame,"Double Correlation",DC_period,Symb1[t],Symb2[t],DC_smoothing,1.0,1,1,DC_MA_period,DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",5,1);
         double _4_l=iCustom(NULL,time_frame,"Double Correlation",DC_period,Symb1[t],Symb2[t],DC_smoothing,1.0,1,1,DC_MA_period,DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",4,2);
         double _5_l=iCustom(NULL,time_frame,"Double Correlation",DC_period,Symb1[t],Symb2[t],DC_smoothing,1.0,1,1,DC_MA_period,DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",5,2);
         _4=NormalizeDouble(_4,4);
         _5=NormalizeDouble(_5,4);
         _4_l=NormalizeDouble(_4_l,4);
         _5_l=NormalizeDouble(_5_l,4);
         if(OPCorrelations) { //   OP
            double _6=iCustom(NULL,time_frame,"Double Correlation",DC_period,Symb1[t],Symb2[t],DC_smoothing,1.0,1,1,DC_MA_period,DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",6,1);
            double _7=iCustom(NULL,time_frame,"Double Correlation",DC_period,Symb1[t],Symb2[t],DC_smoothing,1.0,1,1,DC_MA_period,DC_MA_mode,1,1,1,0,8,"Segoe UI",0,0,0,0,0,"",7,1);
            _6=NormalizeDouble(_6,4);
            _7=NormalizeDouble(_7,4);
            if(_5>_4 && _5_l<=_4_l) {
               close[0]=0;
               if(_6<_7 && ADR1[t]>MinimumADR && ADR2[t]>MinimumADR && PC[t]<=DC_LevelMinus && (PC_half<=half_DC_LevelMinus || !HalfFilter)) signal[0]=1;
               }
            if(_5<_4 && _5_l>=_4_l) {
               close[0]=1;
               if(_6>_7 && ADR1[t]>MinimumADR && ADR2[t]>MinimumADR && PC[t]<=DC_LevelMinus && (PC_half<=half_DC_LevelMinus || !HalfFilter)) signal[0]=0;
               }   
            info_signal=StringConcatenate(Symb1[t]," ",Symb2[t]," OP: ");
            if(signal[0]==1)  info_signal=info_signal+"Sell/Buy "; else
               if(signal[0]==0)  info_signal=info_signal+"Buy/Sell "; else
                  info_signal=info_signal+"None ";
            info_signal=StringConcatenate(info_signal," Cloud now: ",DoubleToStr(_5,4)," ",DoubleToStr(_4,4)," last: ",DoubleToStr(_5_l,4)," ",DoubleToStr(_4_l,4)," Spread: ",DoubleToStr(_6,4)," ",DoubleToStr(_7,4),
                                          " ADR: ",DoubleToStr(ADR1[t],2)," ",DoubleToStr(ADR2[t],2)," PC: ",DoubleToStr(PC[t],2)," PC half: ",DoubleToStr(PC_half,2));
            Print(info_signal);
            }
         if(PPCorrelations) { //   PP
            int trig1=-1,trig2=-1;
            if(iCustom(Symb1[t],time_frame,"Triggerlines",Rperiod,LSMA_Period,2,1)<ask1*2) trig1=0; else trig1=1;
            if(iCustom(Symb2[t],time_frame,"Triggerlines",Rperiod,LSMA_Period,2,1)<ask2*2) trig2=0; else trig2=1;
            if(trig1!=trig2) close[1]=2; 
            if(trig1==trig2) {
               if(trig1==0) close[1]=1;
               if(trig1==1) close[1]=0;
               if(PC[t]>=DC_LevelPlus && ADR1[t]>=MinimumADR && ADR2[t]>=MinimumADR) {
                  if((_5>_4 && _5_l<=_4_l) || (_5<_4 && _5_l>=_4_l)) {
                     if(!HalfFilter || (trig1==half_trig1 && trig1==half_trig2 && PC_half>=half_DC_LevelPlus)) signal[1]=trig1;
                     }
                  }
               }
            info_signal=StringConcatenate(Symb1[t]," ",Symb2[t]," PP: ");
            if(signal[1]==1)  info_signal=info_signal+"Sell/Buy "; else
               if(signal[1]==0)  info_signal=info_signal+"Buy/Sell "; else
                  info_signal=info_signal+"None ";            
            info_signal=StringConcatenate(info_signal," Cloud now: ",DoubleToStr(_5,4)," ",DoubleToStr(_4,4)," last: ",DoubleToStr(_5_l,4)," ",DoubleToStr(_4_l,4)," Trig: ",trig1," ",trig2,
                                          " ADR: ",DoubleToStr(ADR1[t],2)," ",DoubleToStr(ADR2[t],2)," PC: ",DoubleToStr(PC[t],2)," Trig half: ",half_trig1," ",half_trig2);
            Print(info_signal);
            }
         }
      for(c=0;c<2;c++) { //    
         //   ================================================
         int    dir1=-1,         dir2=-1;       //  
         int    num1=0,          num2=0;        //  
         double profit_pips1=0,  profit_pips2=0;//     
         int    ticket1=0,       ticket2=0;     //  
         double stop1=0,         stop2=0;       //   
         double last1=0,         last2=0;       //   
         last_ticket=-1;
         for(i=OrdersTotal()-1;i>=0;i--) if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderMagicNumber()==magic && OrderComment()==pair_name+cor[c]) {
            if(last_ticket==OrderTicket()) continue;
            last_ticket=OrderTicket();
            if(OrderSymbol()==Symb1[t]) {
               dir1=OrderType();
               num1++;
               ticket1=OrderTicket();
               stop1=OrderStopLoss();
               if(dir1==0) {
                  profit_pips1=(bid1-OrderOpenPrice())/Pp1;
                  if(OrderOpenPrice()<last1 || last1==0) last1=OrderOpenPrice();
                  }else{
                  profit_pips1=(OrderOpenPrice()-ask1)/Pp1;               
                  if(OrderOpenPrice()>last1) last1=OrderOpenPrice();
                  }
               }
            if(OrderSymbol()==Symb2[t]) {
               dir2=OrderType();
               num2++;
               ticket2=OrderTicket();
               stop2=OrderStopLoss();
               if(dir2==0) {
                  profit_pips2=(bid2-OrderOpenPrice())/Pp2;
                  if(OrderOpenPrice()<last2 || last2==0) last2=OrderOpenPrice();
                  }else{
                  profit_pips2=(OrderOpenPrice()-ask2)/Pp2;               
                  if(OrderOpenPrice()>last2) last2=OrderOpenPrice();
                  }
               }
            }
         //   ================================================
         //  
         if(close[c]==2 || (close[c]!=-1 && close[c]==dir1) || (signal[c]!=dir1 && signal[c]!=-1) || (dir1==-1 && dir2!=-1) || (dir1!=-1 && dir2==-1)) {
            for(i=OrdersTotal()-1;i>=0;i--) if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderMagicNumber()==magic && OrderComment()==pair_name+cor[c]) CloseOrder(OrderTicket(),-1);
            dir1=-1; dir2=-1;
            }
         //   
         if(dir1==-1 && signal[c]!=-1 && start_work) {
            double lots=First_pair_lot;
            if(Refinans) lots=NormalizeDouble(First_pair_lot*(AccountBalance()/10000),dg);
            if(MartinType==3 || MartinType==4) {
               //    
               int lost_num=0;
               int pair_num=0;
               double pair_profit=0;
               for(i=OrdersHistoryTotal()-1;i>=0;i--) if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) && OrderMagicNumber()==magic && OrderComment()==pair_name+cor[c]) {
                  if(OrderSymbol()==Symb1[t] || OrderSymbol()==Symb2[t]) {
                     pair_num++;
                     pair_profit+=OrderProfit();
                     }
                  if(pair_num>=2) {
                     if(pair_profit>0) break; else {
                        pair_num=0;
                        pair_profit=0;
                        lost_num++;
                        }
                     }             
                  }
               if(lost_num!=0) {
                  if(MartinType==3) lots=NormalizeDouble(lots*MathPow(LotExponent ,lost_num),dg);
                  if(MartinType==4) lots=NormalizeDouble(lots*fibo[lost_num],dg);
                  }
               }
            // 
            if(c==0) {
               if(signal[c]==0) {
                  SendOrder(Symb1[t],0,lots,-1,1,0,1,0,pair_name+cor[c]);
                  SendOrder(Symb2[t],1,lots,-1,1,0,1,0,pair_name+cor[c]);
                  }
               if(signal[c]==1) {
                  SendOrder(Symb2[t],0,lots,-1,1,0,1,0,pair_name+cor[c]);
                  SendOrder(Symb1[t],1,lots,-1,1,0,1,0,pair_name+cor[c]);
                  }
               }
            if(c==1) {
               if(signal[c]==0) {
                  SendOrder(Symb1[t],0,lots,-1,1,0,1,0,pair_name+cor[c]);
                  SendOrder(Symb2[t],0,lots,-1,1,0,1,0,pair_name+cor[c]);
                  }
               if(signal[c]==1) {
                  SendOrder(Symb2[t],1,lots,-1,1,0,1,0,pair_name+cor[c]);
                  SendOrder(Symb1[t],1,lots,-1,1,0,1,0,pair_name+cor[c]);
                  }
               }
            }
         //  
         if(dir1!=-1) {
            //  
            if(TakeProfit!=0 && profit_pips1+profit_pips2>=(ADR1[t]+ADR2[t])*TakeProfit) {
               for(i=OrdersTotal()-1;i>=0;i--) if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderMagicNumber()==magic && OrderComment()==pair_name+cor[c]) CloseOrder(OrderTicket(),-1);
               }
            //  
            if(TrailingStop!=0) {
               double trallpips=ADR1[t]*TrailingStop;
               if(profit_pips1>=trallpips) {
                  if(dir1==0 && bid1-trallpips*Pp1>=stop1+5*Pp1) ModifyOrder(ticket1,-1,bid1-trallpips*Pp1,-1);
                  if(dir1==1 && (ask1+trallpips*Pp1<=stop1-5*Pp1 || stop1==0)) ModifyOrder(ticket1,-1,bid1-trallpips*Pp1,-1);
                  }
               trallpips=ADR2[t]*TrailingStop;
               if(profit_pips2>=trallpips) {
                  if(dir2==0 && bid2-trallpips*Pp2>=stop2+5*Pp2) ModifyOrder(ticket2,-1,bid2-trallpips*Pp2,-1);
                  if(dir2==1 && (ask2+trallpips*Pp2<=stop2-5*Pp2 || stop2==0)) ModifyOrder(ticket2,-1,bid2-trallpips*Pp2,-1);
                  }
               }
            //  ()
            if(MartinType==1) {
               if(num1<SeriesMartin) {
                  if(dir1==0 && ask1<=last1-StepMartin*ADR1[t]) SendOrder(Symb1[t],0,NormalizeDouble(First_pair_lot*MathPow(LotExponent ,num1),dg),-1,1,0,1,0,pair_name+cor[c]);
                  if(dir1==1 && bid1>=last1+StepMartin*ADR1[t]) SendOrder(Symb1[t],1,NormalizeDouble(First_pair_lot*MathPow(LotExponent ,num1),dg),-1,1,0,1,0,pair_name+cor[c]);
                  }
               if(num2<SeriesMartin) {
                  if(dir2==0 && ask2<=last2-StepMartin*ADR2[t]) SendOrder(Symb2[t],0,NormalizeDouble(First_pair_lot*MathPow(LotExponent ,num2),dg),-1,1,0,1,0,pair_name+cor[c]);
                  if(dir2==1 && bid2>=last2+StepMartin*ADR2[t]) SendOrder(Symb2[t],1,NormalizeDouble(First_pair_lot*MathPow(LotExponent ,num2),dg),-1,1,0,1,0,pair_name+cor[c]);
                  }
               }
            if(MartinType==2) {
               if(num1<SeriesMartin) {
                  if(dir1==0 && ask1<=last1-StepMartin*ADR1[t]) SendOrder(Symb1[t],0,NormalizeDouble(First_pair_lot*fibo[num1],dg),-1,1,0,1,0,pair_name+cor[c]);
                  if(dir1==1 && bid1>=last1+StepMartin*ADR1[t]) SendOrder(Symb1[t],1,NormalizeDouble(First_pair_lot*fibo[num1],dg),-1,1,0,1,0,pair_name+cor[c]);
                  }
               if(num2<SeriesMartin) {
                  if(dir2==0 && ask2<=last2-StepMartin*ADR2[t]) SendOrder(Symb2[t],0,NormalizeDouble(First_pair_lot*fibo[num2],dg),-1,1,0,1,0,pair_name+cor[c]);
                  if(dir2==1 && bid2>=last2+StepMartin*ADR2[t]) SendOrder(Symb2[t],1,NormalizeDouble(First_pair_lot*fibo[num2],dg),-1,1,0,1,0,pair_name+cor[c]);
                  }
               }
            }   
         }
      //   for -        
      }
   }
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void init() {
   if (MarketInfo(Symbol(),MODE_LOTSTEP)==0.01) dg=2;
   if (MarketInfo(Symbol(),MODE_LOTSTEP)==0.1)  dg=1;
   if(IsTesting() && !IsVisualMode()) Test=true;
   int k;
   if(!Test) {
      if(CommetSize>0) ArrayResize(CommentBox,CommetSize);
      for(k=0;k<CommetSize;k++) CommentBox[k]="";
      }
      
   //     
   string SymbolsList[];
   int hFile = FileOpenHistory("symbols.raw", FILE_BIN|FILE_READ);
   int SymbolsNumber = FileSize(hFile) / 1936;
   ArrayResize(SymbolsList, SymbolsNumber);
   for(i = 0; i < SymbolsNumber; i++) {
      SymbolsList[i] = FileReadString(hFile, 12);
      FileSeek(hFile, 1924, SEEK_CUR);
      }
      
   //    
   int valuts;
   string valut[];
   int DP_last,DP=-1;
   for(i=0;i<999;i++) {
      if(i==6) break;
      DP_last=DP;
      DP=StringFind(TradingPairs,";",DP+1);
      if(DP==-1) {
         if(StringLen(TradingPairs)==DP_last+1) break;
         valuts++; ArrayResize(valut,valuts);
         valut[valuts-1]=StringSubstr(TradingPairs,DP_last+1,0);
         break;
         }
      DP_last+=1;
      valuts++; ArrayResize(valut,valuts);
      valut[valuts-1]=StringSubstr(TradingPairs,DP_last,DP-DP_last);
      }
      
   //    
   for(i=0;i<valuts;i++) {
      bool check=false;
      for(t=0;t<SymbolsNumber;t++) if(valut[i]==SymbolsList[t]) { check=true; break; }
      if(!check) {
         for(t=i+1;t<valuts;t++) {
            valut[t-1]=valut[t];
            }
         valuts--;
         ArrayResize(valut,valuts);
         }
      }
   
   //    
   int ban_valuts;
   string ban_valut[];
   DP=-1;
   for(i=0;i<999;i++) {
      if(i==6) break;
      DP_last=DP;
      DP=StringFind(BanOnPair,";",DP+1);
      if(DP==-1) {
         if(StringLen(BanOnPair)==DP_last+1) break;
         ban_valuts++; ArrayResize(ban_valut,ban_valuts);
         ban_valut[ban_valuts-1]=StringSubstr(BanOnPair,DP_last+1,0);
         break;
         }
      DP_last+=1;
      ban_valuts++; ArrayResize(ban_valut,ban_valuts);
      ban_valut[ban_valuts-1]=StringSubstr(BanOnPair,DP_last,DP-DP_last);
      }
      
   //   
   for(i=0;i<valuts;i++) {
      for(t=0;t<valuts;t++) {
         if(valut[t]!=valut[i]) {
            pairs++;
            ArrayResize(Symb1,pairs); ArrayResize(Symb2,pairs);
            Symb1[pairs-1]=valut[i];
            Symb2[pairs-1]=valut[t];
            }
         }
      }

   //  
   for(i=0;i<pairs;i++) {
      bool clean=false;
      //    
      for(t=i+1;t<pairs;t++) {
         if(Symb1[i]==Symb1[t] && Symb2[i]==Symb2[t]) { clean=true; break; }
         if(Symb1[i]==Symb2[t] && Symb2[i]==Symb1[t]) { clean=true; break; }
         }
      //   
      if(!clean) {
         for(t=0;t<ban_valuts;t++) {
            if(StringConcatenate(Symb1[i],"-",Symb2[i])==ban_valut[t]) { clean=true; break; }
            if(StringConcatenate(Symb2[i],"-",Symb1[i])==ban_valut[t]) { clean=true; break; }
            }
         }
      // 
      if(clean) {
         for(t=i+1;t<pairs;t++) {
            Symb1[t-1]=Symb1[t];
            Symb2[t-1]=Symb2[t];
            }
         pairs-=1;
         ArrayResize(Symb1,pairs); ArrayResize(Symb2,pairs);
         i--;
         }         
      }
      
   //   
   for(i=0;i< pairs;i++) {
      Symb1[i]=Symb1[i]+DopSymbol;
      Symb2[i]=Symb2[i]+DopSymbol;
      }
   
   //!!!!!!!!!!!!!!!!!!!!
   cm2="  "+pairs+": ";
   for(i=0;i< pairs;i++) {
      cm2=cm2+Symb1[i]+"-"+Symb2[i]+" ";
      }
   Print(cm2);
   //!!!!!!!!!!!!!!!!!!!!
   ArrayResize(ADR1,pairs);
   ArrayResize(PC,pairs);
   ArrayResize(ADR2,pairs);
   ArrayResize(time_bar,pairs);
   ArrayResize(fibo,50);
   fibo[0]=1;
   fibo[1]=1;
   for(i=2;i<50;i++) fibo[i]=fibo[i-1]+fibo[i-2];
   return;
   }
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void deinit() {
   Comment("");
   return;
   }
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

   
/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
>>>           
>>> :
>>>   int      Type     -    (0-BUY, 1-SELL, 2-BUYLIMIT, 3-SELLLIMIT, 4-BUYSTOP, 5-SELLSTOP
>>>   double   LT       -   
>>>   
>>>   double   OP       -      ( Type  0  1,    )
>>>   int      ModeSL   -     (0-  , 1-)
>>>   double   SL       -  
>>>   int      ModeTP   -     (0-  , 1-)
>>>   double   TP       -  
>>>   string   CM       -  
>>>   int      MG       -  
>>>   
>>>  :
>>>    TRUE    .  FALSE    .
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
bool SendOrder(string Symb,int Type ,double LT ,double OP=-1 ,int ModeSL=0 ,double SL=0 ,int ModeTP=0 ,double TP=0, string CM="", int MG=-1) {
   if(MG==-1) MG=magic;
   dig=MarketInfo(Symb,MODE_DIGITS);
   Pp=Point;
   if (Pp==0.00001 || Pp==0.001) Pp*=10; 
   color CL;
   int k,Ticket,LastError;
   bool TickeT;
   if (Type==0) CL=Blue; else  if (Type==1) CL=Red; else  if (Type==2 || Type==4) CL=DarkTurquoise; else if (Type==3 || Type==5) CL=Orange;
   //  
   if(Type==0 || Type==2 || Type==4) {
      if(!long_allowed) return(false);
      }else{
      if(!short_allowed) return(false);
      }
   //  
   if (LT*MarketInfo(Symb,MODE_MARGINREQUIRED)>AccountEquity()) {
      PnC(StringConcatenate("[S]      ",TypeToStr(Type)," : ",DoubleToStr(LT,dg)),1);
      Work=false;
      return(false);
      }
   //   
   double Slv=MarketInfo(Symb,MODE_STOPLEVEL)*Point;
   double sask,sbid;
   sask=MarketInfo(Symb,MODE_ASK);
   sbid=MarketInfo(Symb,MODE_BID);
   switch(Type) {
      case 2: if(sask-OP<Slv) OP=sask-Slv; break;
      case 3: if(OP-sbid<Slv) OP=sbid+Slv; break;
      case 4: if(OP-sask<Slv) OP=sask+Slv; break;
      case 5: if(sbid-OP<Slv) OP=sbid-Slv; break;
      }
   // 
   for(k=0;k<TryToTrade;k++) {
      RefreshRates(); 
      if (Type==0) OP=MarketInfo(Symb,MODE_ASK);
      if (Type==1) OP=MarketInfo(Symb,MODE_BID); 
      PnC(StringConcatenate("[S]  , : ",Symb," : ",TypeToStr(Type)," : ",DoubleToStr(LT,dg),"  : ",DoubleToStr(OP,dig)),0); 
      if (IsTradeAllowed()) {
         Ticket=OrderSend(Symb,Type,LT,NormalizeDouble(OP,dig),3,0,0,CM,MG,0,CL);
         }else{ 
         PnC(StringConcatenate("[S]   ,  ",k),0); 
         Sleep(WaitTime); 
         continue; 
         }
      if (Ticket > 0) { 
         PnC(StringConcatenate("[S]    ",Ticket),0); 
         break; 
         }
      LastError=Fun_Error(GetLastError());
      switch(LastError) {
         case 0: 
            if (k==TryToTrade) return(false);
            Sleep(WaitTime); 
            break;
         case 1:
            return(false);
         case 2:
            Work=false; 
            return(false); 
         }
      }
   if (SL==0 && TP==0) return(true);
   if(!OrderSelect(Ticket,SELECT_BY_TICKET)) {
      PnC(StringConcatenate("[S]     ",Ticket,"   "),1); 
      return(false);
      }
   //    
   if(SL!=0) {
      if (ModeSL==1) {
         if (Type==0 || Type==2 || Type==4) SL=OrderOpenPrice()-SL*Pp; else SL=OrderOpenPrice()+SL*Pp;
         }
      if (MathAbs(OrderOpenPrice()-SL)<Slv && SL!=0) {
         if (Type==0 || Type==2 || Type==4) SL=OrderOpenPrice()-Slv; else SL=OrderOpenPrice()+Slv;
         }
      }
   if(TP!=0) {
      if (ModeTP==1) {
         if (Type==0 || Type==2 || Type==4) TP=OrderOpenPrice()+TP*Pp; else TP=OrderOpenPrice()-TP*Pp;
         }     
      if (MathAbs(OrderOpenPrice()-TP)<Slv && TP!=0) {
         if (Type==0 || Type==2 || Type==4) TP=OrderOpenPrice()+Slv; else TP=OrderOpenPrice()-Slv;
         }
      }
   //  
   for(k=0;k<TryToTrade;k++) {
      PnC(StringConcatenate("[S]    : ",Ticket," /: ",DoubleToStr(SL,dig)," /: ",DoubleToStr(TP,dig)),0);
      if (IsTradeAllowed()) {
         TickeT=OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(SL,dig),NormalizeDouble(TP,dig),0,CLR_NONE);
         }else{ 
         PnC(StringConcatenate("[S]   ,  ",k),0); 
         Sleep(WaitTime); 
         continue; 
         }
      if (TickeT) { 
         PnC(StringConcatenate("[S]    ",Ticket),0); 
         break; 
         }
      LastError=Fun_Error(GetLastError());
      switch(LastError) {
         case 0: 
            if (k==TryToTrade) return(false);
            Sleep(WaitTime); 
            break;
         case 1:
            return(false);
         case 2:
            Work=false; 
            return(false); 
         }
      }
   return(true);
   }
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
>>>           
>>> :
>>>   int      Ticket   -  
>>>   
>>>   double   OP       -    .  -1 -   
>>>   double   SL       -    .  -1 -   
>>>   double   TP       -    .  -1 -   
>>>   
>>>  :
>>>    TRUE    .  FALSE    .
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
bool ModifyOrder (int Ticket,double OP=-1,double SL=-1,double TP=-1) {
   bool TickeT;
   int k,LastError;
   TickeT=OrderSelect(Ticket,SELECT_BY_TICKET);
   if (!TickeT) {
      PnC("[M]      ",0);
      return(false);
      }
   if (OrderCloseTime()>0) {
      PnC("[M]     ",0);
      return(false);
      }
   dig=MarketInfo(OrderSymbol(),MODE_DIGITS);
   string cm;
   if(OP<0) OP=OrderOpenPrice(); else cm=" " + DoubleToStr(OrderOpenPrice(),dig) + " => " + DoubleToStr(OP,dig) + "; ";
   if(SL<0) SL=OrderStopLoss(); else cm=cm+"/ " + DoubleToStr(OrderStopLoss(),dig) + " => " + DoubleToStr(SL,dig) + "; ";
   if(TP<0) TP=OrderTakeProfit(); else cm=cm+"/ " + DoubleToStr(OrderTakeProfit(),dig) + " => " + DoubleToStr(TP,dig) + "; ";
   for(k=0;k<TryToTrade;k++) {
      PnC(StringConcatenate("[M]  : ",Ticket," ",cm),0);
      if (IsTradeAllowed()) {
         TickeT=OrderModify(Ticket,NormalizeDouble(OP,dig),NormalizeDouble(SL,dig),NormalizeDouble(TP,dig),0,CLR_NONE);
         }else{ 
         PnC(StringConcatenate("[M]   ,  ",k),0); 
         Sleep(WaitTime); 
         continue; 
         }
      if (TickeT ==true) { 
         PnC(StringConcatenate("[M]    ",Ticket),0); 
         return(true); 
         }
      LastError=Fun_Error(GetLastError());
      switch(LastError) {
         case 0: 
            if (k==TryToTrade) return(false);
            Sleep(WaitTime); 
            break;
         case 1:
            return(false);
         case 2:
            Work=false; 
            return(false); 
         }
      }
   return(true);
   }
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
>>>           
>>> :
>>>   int      Ticket   -  
>>>   
>>>   double   LT       -    .  -1 -    
>>>   
>>>  :
>>>    TRUE    .  FALSE    .
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
bool CloseOrder(int Ticket,double LT=-1) {
   bool TickeT;
   double OCP;
   int k,LastError;
   TickeT=OrderSelect(Ticket,SELECT_BY_TICKET);
   if (!TickeT) {
      PnC("[C]      ",0);
      return(false);
      }
   if (OrderCloseTime()>0) {
      PnC("[C]     ",0);
      return(false);
      }
   Symb=OrderSymbol();
   dig=MarketInfo(Symb,MODE_DIGITS);
   int Type=OrderType();
   if (Type>1) {
      PnC("[C]   ,   ",0);
      return(false);
      }
   if(LT==-1) LT=NormalizeDouble(OrderLots(),dg); else LT=NormalizeDouble(LT,dg);
   for(k=0;k<=TryToTrade;k++) {
      if (Type==0) OCP=MarketInfo(Symb,MODE_BID);
      if (Type==1) OCP=MarketInfo(Symb,MODE_ASK); 
      PnC(StringConcatenate("[C]   ",TypeToStr(Type)," : ",Ticket," : ",DoubleToStr(LT,dg),"  : ",DoubleToStr(OCP,dig)),0);
      if (IsTradeAllowed()) {
         TickeT=OrderClose(Ticket,LT,NormalizeDouble(OCP,dig),30,White);
         }else{ 
         PnC(StringConcatenate("[C]   ,  ",k),0); 
         Sleep(WaitTime); 
         continue; 
         }
      if (TickeT) { 
         PnC(StringConcatenate("[C]    ",Ticket),0); 
         return(true); 
         }
      LastError=Fun_Error(GetLastError());
      switch(LastError) {
         case 0: 
            if (k==TryToTrade) return(false);
            Sleep(WaitTime); 
            break;
         case 1:
            return(false);
         case 2:
            Work=false; 
            return(false); 
         }
      }
   return(true);
   }
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
>>>           
>>> :
>>>   int      Ticket   -  
>>>   
>>>  :
>>>    TRUE    .  FALSE    .
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
bool DeleteOrder(int Ticket) {
   bool TickeT;
   int k,LastError;
   TickeT=OrderSelect(Ticket,SELECT_BY_TICKET);
   if (!TickeT) {
      PnC("[D]      ",0);
      return(false);
      }
   if (OrderCloseTime()>0) {
      PnC("[D]     ",0);
      return(false);
      }
   int Type=OrderType();
   if (Type<2) {
      PnC("[D]   ,    ",0);
      return(false);
      }
   for(k=0;k<=TryToTrade;k++) {
      PnC(StringConcatenate("[D]  : ",Ticket," : ",Type),0);
      if (IsTradeAllowed()) {
         TickeT=OrderDelete(Ticket);
         }else{ 
         PnC(StringConcatenate("[D]   ,  ",k),0); 
         Sleep(WaitTime); 
         continue; 
         }
      if (TickeT) { 
         PnC(StringConcatenate("[D]    ",Ticket),0); 
         return(true); 
         }
      LastError=Fun_Error(GetLastError());
      switch(LastError) {
         case 0: 
            if (k==TryToTrade) return(false);
            Sleep(WaitTime); 
            break;
         case 1:
            return(false);
         case 2:
            Work=false; 
            return(false); 
         }
      }
   return(true);
   }
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
>>>           
>>> :
>>>                 , 
>>>             (Alert).
>>>
>>> :
>>>   string   txt      -  
>>>   int      Mode     -   (0- Print, 1-Print  Alert, 2-)
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
void PnC(string txt,int Mode) {
   int j;
   if(Mode!=2) {
      string HR=DoubleToStr(Hour(),0);    if (StringLen(HR)<2) HR="0"+HR;
      string MN=DoubleToStr(Minute(),0);  if (StringLen(MN)<2) MN="0"+MN;
      string SC=DoubleToStr(Seconds(),0); if (StringLen(SC)<2) SC="0"+SC;
      txt=StringConcatenate(HR,":",MN,":",SC,"; ",txt);
      Print(txt);
      if(Test) return;
      if (Mode>0) Alert(txt);
      for(j=CommetSize-1;j>=1;j--) CommentBox[j]=CommentBox[j-1];
      CommentBox[0]=txt;
      }
   if(CommetSize>0) { 
      string cm;
      for(j=CommetSize-1;j>=0;j--) if(CommentBox[j]!="") cm=StringConcatenate(cm,CommentBox[j],"\n");
      cm=StringConcatenate(cm,"\n",cm2);
      Comment(cm); 
      }
   }
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
>>>            
>>> :
>>>    ,       
>>>
>>> :
>>>   int      Type     -    (0-BUY, 1-SELL, 2-BUYLIMIT, 3-SELLLIMIT, 4-BUYSTOP, 5-SELLSTOP
>>>   
>>>  :
>>>            .     "NONE".
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
string TypeToStr(int Type) {
   switch(Type) {
      case 0: return("BUY");
      case 1: return("SELL");
      case 2: return("BUYLIMIT");
      case 3: return("SELLLIMIT");
      case 4: return("BUYSTOP");
      case 5: return("SELLSTOP");
      }
   return("NONE");
   }
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
>>>           
>>> :
>>>          ,               .
>>>       4110  4111 (         )   long.allowed  
>>>   short.allowed  false        SendOrder      
>>>
>>> :
>>>   int      er       -  
>>>   
>>>  :
>>>            :
>>>   0 -     
>>>   1 -     
>>>   2 -    
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
int Fun_Error(int er) {
   switch(er) {
      //  1:   
      case 2: PnC(" ",0); return(0);
      case 4: PnC("  ",0); return(0);
      case 8: PnC("  ",0); return(0);
      case 129: PnC(" ",0); return(0);
      case 135: PnC(" ",0); return(0);
      case 136: PnC(" ",0); return(0);
      case 137: PnC(" ",0); return(0);
      case 138: PnC(" ",0); return(0);
      case 141: PnC("  ",0); return(0);
      case 146: PnC("  ",0); return(0);
      //  2:  
      case 0: PnC(" ",0); return(1);
      case 1: PnC(" ,    ",0); return(1);
      case 3: PnC(" ",0); return(1);
      case 6: PnC("    ",0); return(1);
      case 128: PnC("    ",0); return(1);
      case 130: PnC(" ",0); return(1);
      case 131: PnC(" ",0); return(1);
      case 132: PnC(" ",0); return(1);
      case 133: PnC(" ",0); return(1);
      case 134: PnC("    ",0); return(1);
      case 139: PnC("    ",0); return(1);
      case 145: PnC(" ,       ",0); return(1);
      case 148: PnC("      ,  ",0); return(1);
      case 4000: PnC(" ",0); return(1);
      case 4107: PnC("     ",0); return(1);
      case 4108: PnC("  ",0); return(1);
      case 4110: PnC("BUY   ",0); long_allowed=false; return(1);
      case 4111: PnC("SELL   ",0); short_allowed=false; return(1);
      //  3:  
      case 5: PnC("   ",1); return(2);
      case 7: PnC(" ",1); return(2);
      case 9: PnC("    ",1); return(2);
      case 64: PnC(" ",1); return(2);
      case 65: PnC("  ",1); return(2);
      case 140: PnC("  ",1); return(2);
      case 147: PnC("     ",1); return(2);
      case 149: PnC("        ,   ",1); return(2);
      case 150: PnC("         FIFO",1); return(2);
      case 4109: PnC("  ,      ",1); return(2);
      }
   }                     
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


